//Создание задачи диспетчерского вызова прочих задач
function LocalManageSystemFormalModelingProject(ErrorFunction,..//Функция нештатных ситуаций
                                                ReadFunction,..//Функция получения сообщения
                                                DisplayFunction,..//Функция отправки сообщения
                                                ProjectDirectory..//Имя директории проекта
                                                )
    //Анализируем аргументы
    nArg = argn(2);
    if nArg < 3 then
        error('the function ManageSystemFormalModelingProject takes 3 or 4 arguments');
    elseif nArg == 3 then
        ProjectDirectory = pwd();
    end
    
    //Обрабатываем функцию считывания
    select type(ReadFunction)
    case 10 then
        execstr('readFunction = ' + ReadFunction);
    case 15 then
        //Получаем имя функции отображения и ее параметры
        rFunction = ReadFunction(1);
        rFunctionParametrs = ReadFunction(2:$);
        
        //Приводим имя функции к типу функции
        execstr('rFunction = ' + rFunction);
        
        //Формируем функцию вызова
        function [msg]=readFunction(askStr)
            msg=rFunction(askStr,rFunctionParametrs(:));
        endfunction
    end
    
    //Обрабатываем функцию отображения
    select type(DisplayFunction)
    case 10 then
        execstr('displayFunction = ' + DisplayFunction);
    case 15 then
        //Получаем имя функции отображения и ее параметры
        dFunction = DisplayFunction(1);
        dFunctionParametrs = DisplayFunction(2:$);
        
        //Приводим имя функции к типу функции
        execstr('dFunction = ' + dFunction);
        
        //Формируем функцию вызова
        function displayFunction(msg)
            dFunction(msg,dFunctionParametrs(:));
        endfunction
    end
    
    //Создаем проект
    msg = readFunction('Create project? (Y/N): ');
    if or(msg == ['N','n']) then
        ProjectName = readFunction('Name of project: ');//Имя проекта
    else
        [ProjectName,..//Имя проекта
         err,msg]=CreateSystemFormalModelingProject(DisplayFunction,..//Функция отправки сообщения
                                                    ReadFunction,..//Функция получения сообщения задачам
                                                    'TaskDisplayMsgFunction',..//Функция отправки сообщения от задач
                                                    ProjectDirectory,..//Имя директории проекта
                                                    %f);
        if err ~= 0 then
            displayFunction('ERROR: ' + msg);
        end
    end
    
    //Запускаем текущие задачи
    LocalSolveAllTasks(ErrorFunction,DisplayFunction,ProjectName);
    
    //Получаем результат
    msg = readFunction('Receive rezults'' datas files? (Y/N): ');
    if ~or(msg == ['N','n']) then
        //Получаем имена файлов результатов
        rezultFilesNames = readFunction('Results'' files names: ');
        rezultFilesNames = stripblanks(strsplit(rezultFilesNames,','));
        
        //Получаем имя директории, куда сохраним файлы
        rezultFilesDirectoriesName = readFunction('Results'' files directory(ies) name: ');
        rezultFilesDirectoriesName = stripblanks(strsplit(rezultFilesDirectoriesName,','));
        
        //Получаем из облака файлы результатов
        [err,msg] = ReceiveDatasTasks(rezultFilesNames,..
                                      ProjectName,..
                                      rezultFilesDirectoriesName,%t,%f);
        if err ~= 0 then
            displayFunction('ERROR: ' + msg);
        end
    end
    
    //Удаляем проект
    msg = readFunction('Delete project? (Y/N): ');
    if ~or(msg == ['N','n']) then
        [err,msg] = RemoveProjects(ProjectName,%f);
        if err ~= 0 then
            displayFunction('ERROR: ' + msg);
        end
    end
endfunction
